﻿@page "{OrderID}"
@using System.Text.Encodings.Web;
@inject IStringLocalizer StringLocalizer;
@model Canyon.GM.Panel.Areas.Purchases.Pages.IndexModel
@{
    ViewData[TITLE] = StringLocalizer["PurchaseInformation"];
    string returnUrl = Url.Page("List", new { area =  "Purchases"});
    if (!string.IsNullOrEmpty(Model.ReturnUrl) && Url.IsLocalUrl(Model.ReturnUrl))
    {
        returnUrl = Model.ReturnUrl;
    }
}
<div class="mb-2">
    <a class="btn btn-primary" href="@returnUrl">
        <i class="fa-solid fa-chevron-left" aria-hidden="true"></i>
        @StringLocalizer["GoBack"]
    </a>
</div>
<div class="mt-30 mb-40">
    <div class="row">
        <div class="col-md-6">
            <h2>@StringLocalizer["BuyerInformation"]</h2>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["UserID"]</label>
                <div class="col-sm-8">
                    @Model.PaymentOrder.User.Id
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["UserName"]</label>
                <div class="col-sm-8">
                    @Model.PaymentOrder.User.UserName
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["Email"]</label>
                <div class="col-sm-8">
                    @Model.PaymentOrder.User.Email
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["EmailConfirmed"]</label>
                <div class="col-sm-8">
                    @(Model.PaymentOrder.User.EmailConfirmed ? StringLocalizer["Yes"] : StringLocalizer["No"])
                </div>
            </div>
        </div>
        <div class="col-md-6">
            <h2>@StringLocalizer["PaymentInformation"]</h2>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["OrderID"]</label>
                <div class="col-sm-8">
                    @Model.OrderID
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["PaymentMethod"]</label>
                <div class="col-sm-8">
                    @StringLocalizer[Model.PaymentOrder.Method.Name]
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["PaymentStatus"]</label>
                <div class="col-sm-8">
                    @StringLocalizer[Model.PaymentOrder.Status.ToString()]
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["CreationDate"]</label>
                <div class="col-sm-8">
                    @Model.PaymentOrder.CreatedAt.ToString()
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["LastUpdate"]</label>
                <div class="col-sm-8">
                    @Model.PaymentOrder.UpdatedAt?.ToString()
                </div>
            </div>
            <div class="row mt-2">
                <label class="control-label col-sm-4">@StringLocalizer["LastNotification"]</label>
                <div class="col-sm-8">
                    @if (Model.MercadoPagoHistory != null)
                    {
                        @(Model.MercadoPagoHistory.UpdatedAt?.ToString() ?? Model.MercadoPagoHistory.CreatedAt.ToString())
                    }
                    else
                    {
                        @StringLocalizer["Never"]
                    }
                </div>
            </div>
        </div>
        <div class="col-md-6 mt-5">
            <h2>@StringLocalizer["CartInformation"]</h2>
            <div class="table-responsive">
                <table class="table table-bordered">

                    <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">@StringLocalizer["ProductName"]</th>
                            <th scope="col">@StringLocalizer["Amount"]</th>
                            <th scope="col">@StringLocalizer["PaidPrice"]</th>
                            <th scope="col">@StringLocalizer["Total"]</th>
                        </tr>
                    </thead>

                    <tbody>
                        @foreach (var item in Model.PaymentOrder.Items)
                        {
                            <tr>
                                <td>@item.ProductId</td>
                                <td>@StringLocalizer[item.Product.Name]</td>
                                <td>@item.Amount</td>
                                <td>@item.Price.ToString("N2")</td>
                                <td>@((item.Price * item.Amount).ToString("N2"))</td>
                            </tr>
                        }
                    </tbody>

                    <tfoot>

                        <tr>
                            <td>@StringLocalizer["Total"]</td>
                            <td colspan="4" class="text-end">@Model.PaymentOrder.Items.Sum(x => x.Amount * x.Price).ToString("N2")</td>
                        </tr>

                    </tfoot>
                </table>
            </div>
        </div>
        @if (Model.PaymentOrder.CreditCards?.Count > 0)
        {
            <div class="col-md-6 mt-5">
                <h2>@StringLocalizer["Cards"]</h2>
                <div class="table-responsive">
                    <table class="table table-bordered">
                        <thead class="thead-default">
                            <tr>
                                <th>Código do cartão</th>
                                <th>Usado em</th>
                                <th>Cancelado em</th>
                                <th>&nbsp;</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var card in Model.PaymentOrder.CreditCards)
                            {
                                <tr>
                                    <td>
                                        <strong>@card.CardUUID</strong>
                                        @if (card.CardType.VipLevel > 0)
                                        {
                                            <br /> <small>@StringLocalizer["VIPLevel"]: @card.CardType.VipLevel (@StringLocalizer["Duration"]: @TimeSpan.FromMinutes(card.CardType.VipLevelDuration) @StringLocalizer["days"])</small>
                                        }
                                        @if (card.CardType.Silvers > 0)
                                        {
                                            <br /> <small>@StringLocalizer["Silvers"]: @($"{card.CardType.Silvers:N0}")</small>
                                        }
                                        @if (card.CardType.ConquerPoints > 0)
                                        {
                                            <br /> <small>@StringLocalizer["ConquerPoints"]@(card.CardType.ConquerPointsMono ? "(B)" : ""): @($"{card.CardType.ConquerPoints:N0}")</small>
                                        }
                                        @if (card.CardType.ItemType > 0)
                                        {
                                            <br /> <small>@StringLocalizer["HasItemOrSpecial"]</small>
                                        }
                                    </td>
                                    <td>
                                        @if (card.UsedBy != null)
                                        {
                                            @card.UpdatedAt?.ToString()
                                        }
                                        else
                                        {
                                            @StringLocalizer["Never"]
                                        }
                                    </td>
                                    <td>@(card.CancelledAt?.ToString() ?? StringLocalizer["Never"])</td>
                                    <td>
                                        @if (card.CancelledAt == null && card.UsedBy == null)
                                        {
                                            <form class="cancel-credit-card-frm" method="post" asp-page-handler="CancelCard">
                                                <button type="submit" class="btn btn-sm btn-danger"><i class="fa fa-close" aria-hidden="true"></i></button>
                                            </form>
                                        }
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>
                </div>
            </div>
        }
    </div>
</div>

@section Scripts
{
    <script>
        const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]');
        const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl));

        $('.cancel-credit-card-frm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer.GetString("CancelCreditCard")',
                messageText: '@StringLocalizer["CancelCreditCardAlert"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

    </script>
}